program Ultimatch_row
  
	use sep
	use cartesian
	use row_findnsmatch_mod

  implicit none

  integer, external                    :: getch
  real,          pointer, dimension(:) :: data1,data2,data3,data4,target,out
  type (nfilter), pointer              :: sig_pef
  type (filter)                        :: match1,match2,laplac,laplac1,laplac2
  type (filter), pointer, dimension(:) :: nmatch
  type (nfilter)                       :: nsmatch1,nsmatch2,nsmatch

  integer :: ndim               ! dimension of dataset
  integer :: niter
  integer :: ntimes
	integer :: rows				! 1= use row operation =0 normal operation
  real    :: eps,noise,rbar,eps2,mu
  logical :: twodim,interleave 
  character (len=20) :: targetname
  integer, dimension(:), pointer :: nfilt  ! no. of coefficients in each filter
  integer, dimension(:), pointer :: n      ! data-size, dimension(ndim)
  real,    dimension(:), pointer :: d, o
  integer, dimension(:), pointer :: npatch ! no. of patches, dimension(ndim)
  integer, dimension(:), pointer :: nwind  ! overlapping patch-size
  integer, dimension(:), pointer :: idx    ! index counter (ndim)

  integer, dimension(:), pointer :: nh    ! length of each filter in the table
  integer, dimension(:), pointer :: pch   ! ns filter indexing
  integer, dimension(:), pointer :: psize ! non-overlapping patch-size

  integer, dimension(:), pointer :: nfpef ! no. of coefficients for PEFs

  integer :: i,stat,ilag,ipatch,idim,ipanels,npanels ! junk variables
	integer	:: nhmax
  
  integer                                :: j,j_dat(2)
  type(nfilter), pointer,save            :: noiz_pef
  type(nfilter), pointer,save            :: noiz_rough,data_rough
  integer                                :: ncoef_data
  real, pointer, dimension(:)            :: temp_array
  logical                                :: rad,ste
  
  call sep_init(SOURCE)
  ndim=sep_dimension()

  allocate(n(ndim), o(ndim), d(ndim))
  call from_history('n',n)
  call from_history('o',o)
  call from_history('d',d)

  call from_param('2D',twodim,.false.)
  write(0,*) '2D',twodim
  npanels=1
  if (twodim) then
     allocate(nfilt(2))
     nfilt=n(1:2)
     npanels=1
     if (ndim>2) npanels=n(3)
     if (interleave) then 
        npanels=1
        if (ndim>3) npanels=n(4)
        call to_history('n3',npanels)
        call to_history('n4',1)
     end if
     deallocate(n)
     ndim=2
     allocate(n(2))
     n=nfilt
     deallocate(nfilt)
  end if

  allocate(nfilt(ndim),idx(ndim),nfpef(ndim))
  nfilt=1; nfilt(1)=21

  call from_param('ntimes',ntimes,1)
  call from_param('verb',verb,10)
  call from_param('nfilt',nfilt,nfilt)
  call from_param('row',rows,0)
  call from_param('mu',mu,0.5)

  call from_param('niter',niter,product(nfilt)-1)
  call from_param('eps',eps,1.) ! for the adaptive subtraction

  ! Patching parameters
  allocate(npatch(ndim),nwind(ndim))
  npatch=1
  call from_param('npatch',npatch,npatch)
  call from_param('noise',noise,0.)
  do i=1,ndim
     if (npatch(i)==1) then 
        nwind(i)=n(i)
     else 
        nwind(i)=2*n(i)/npatch(i)
     end if
  end do

	allocate(data1(product(n)),data2(product(n)))
	allocate(target(product(n)),out(product(n)))

  ! Create a single filter
  call allocatehelix(match1,product(nfilt))
  call allocatehelix(match2,product(nfilt))
  do ilag=1,product(nfilt)
     call line2cart(nfilt,ilag,idx)
     match1%lag(ilag)=idx(1)-nfilt(1)/2-1
     match2%lag(ilag)=idx(1)-nfilt(1)/2-1
     do idim=2,ndim
        match1%lag(ilag)=match1%lag(ilag)+(idx(idim)-nfilt(idim)/2-1)*product(n(1:idim-1))
        match2%lag(ilag)=match2%lag(ilag)+(idx(idim)-nfilt(idim)/2-1)*product(n(1:idim-1))
     end do
  end do

	if (verb>0) write(0,*) '#####################################'
	if (verb>0) write(0,*) '# Non-stationary matched-filtering...'
	if (verb>0) write(0,*) '#------------------------------------'
	if (verb>1) write(0,*) '#    ndim   = ',ndim
	if (verb>1) write(0,*) '#    n      = ',n
	if (verb>1) write(0,*) '#    npatch = ',npatch
	if (verb>1) write(0,*) '#    nfilt  = ',nfilt

	!! Create a non-stationary filter
	allocate(nh(product(npatch)))      !! nh is the length of each filter in table
	nh=product(nfilt)                  !! Set them all constant
	call psize_init(n,npatch,psize)    !! psize(ndim) is the patch-size
     
	if (verb>0) write(0,*) '#    patch-size = ',psize
	if (verb>0) write(0,*) '#####################################'
     
	call pch_init(n,npatch,psize,pch)  !! pch(ndata) is the index
	call nallocate(nsmatch1,nh,pch)
	call nallocate(nsmatch2,nh,pch)

	!! initialize the non-stationary filters
	do ipatch=1,product(npatch)
		nsmatch1%hlx(ipatch)%lag=match1%lag
		nsmatch2%hlx(ipatch)%lag=match2%lag
	end do

	!! compute the helix version of the laplacian regularizer
	nhmax=size(nsmatch1%hlx(1)%lag)+size(nsmatch2%hlx(1)%lag)
	call laplac1_init(laplac,nhmax,npatch) !! laplac is the regularizer

	!! if primaries requested as output, write out the history file parameters
	if (exist_file("Primaries_out")) then
        call to_history('n',n,"Primaries_out")
        call to_history('d',d,"Primaries_out")
        call to_history('o',o,"Primaries_out")
	end if

	!! compute the filters panel by panel
	panels:do ipanels=1,npanels

		if (verb>1) write(0,*) '###################################'
		if (verb>1) write(0,*) '   Panel = ',ipanels,' out of ',npanels
		if (verb>1) write(0,*) '-----------------------------------'

		out=0.
     
		! Read in data
     
		call sep_read(data1)
		call sep_read(data2,'Primaries_in')
        call sep_read(target,'target')

		if ((maxval(data1).eq.minval(data1)).or.(maxval(data2).eq.minval(data2))) then
			call sep_write(out)
			cycle
		end if

		! NS filters
           
		if (verb>2) write(0,*) ' -------------------------------------'
		if (verb>2) write(0,*) ' Calling row findnsmatch with no weight...'
		if (verb>2) write(0,*) ' -------------------------------------'
           
		!! the 1 is for regularized solver.
		call row_findnsmatch(data1,data2,target,nsmatch1,nsmatch2,&
			& laplac,1,eps,mu)
           
		!! Apply the first filter to the data to get the matched multiples
		call applynsmatch(data1,out,nsmatch1) 
        
		!! output the matched multiples
		call sep_write(out)
        
		!! if requested, apply the second filter to the data to get 
		!!	the matched primaries
		if (exist_file("Primaries_out")) then
			call applynsmatch(data1,out,nsmatch2) 
			call srite("Primaries_out",out,4*size(out))
		end if 

	end do panels
  
	write(0,*) '---- The End ----'
  
	call sep_close()
  
contains
     
  !! Calculate non-overlapping patch-size given a certain number of patches
  subroutine psize_init(n,npatch,psize)
    integer, dimension(:), intent(in)  :: n,npatch
    integer, dimension(:), pointer     :: psize
    allocate(psize(ndim))
    do i=1,ndim
       psize(i)=1+(n(i)-1)/npatch(i)
    end do
  end subroutine psize_init

  !! Divides data-space between rectangular patches
  subroutine pch_init(n,npatch,psize,pch)
    integer, dimension(:), intent(in)  :: n,npatch,psize
    integer, dimension(:), pointer     :: pch,ii
    integer :: i,j

    allocate(pch(product(n)),ii(size(n)))
    do i=1,product(n)
       pch(i)=0
       call line2cart(n,i,ii)
       do j=1,size(n)
          ii(j)=(1+(ii(j)-1)/psize(j))
       end do
       call cart2line(npatch,ii,pch(i))
    end do
    deallocate(ii)
  end subroutine pch_init
  
  !! Create a roughener to dampen NS filter estimation
  subroutine laplac_init(laplac,nsfilt,npatch)
    type  (filter)        :: laplac
    type (nfilter)        :: nsfilt
    integer, dimension(:) :: npatch

    real    :: e1,e2
    integer :: nhmax
    nhmax=size(nsfilt%hlx(1)%lag)

    write(0,*) 'size',size(npatch)
    select case(size(npatch))
    case (1)
       call allocatehelix(laplac,1)  
       laplac%lag(1)=nhmax;   laplac%flt(1)=-.99
    case (2)
       !! 1-D smoothing only

       ! crap 2-D smoothing
       call allocatehelix(laplac,3)  
       laplac%lag=(/ nhmax, npatch(1)*nhmax, nhmax*(npatch(1)+1)  /)
       e1=0.2; e2=0.1
       laplac%flt=(/ e1-1.,      e2-1.,     (1.-e1)*(1.-e2)  /)

       if (verb>5) then
          write(0,*) '  Roughening filter...'
          call dumpfilter(laplac)
       end if

    case default
       write(0,*) 'Testmatch'
       call seperr('dimensionality not implemented')
    end select

  end subroutine laplac_init

  !! Create a roughener to dampen NS filter estimation
  subroutine laplac1_init(laplac,nhmax,npatch)
    type  (filter)        :: laplac
	integer					:: nhmax
    integer, dimension(:) :: npatch

    real    :: e1,e2

    write(0,*) 'size',size(npatch)
    select case(size(npatch))
    case (1)
       call allocatehelix(laplac,1)  
       laplac%lag(1)=nhmax;   laplac%flt(1)=-.99
    case (2)
       !! 1-D smoothing only

       ! crap 2-D smoothing
       call allocatehelix(laplac,3)  
       laplac%lag=(/ nhmax, npatch(1)*nhmax, nhmax*(npatch(1)+1)  /)
       e1=0.2; e2=0.1
       laplac%flt=(/ e1-1.,      e2-1.,     (1.-e1)*(1.-e2)  /)

       if (verb>5) then
          write(0,*) '  Roughening filter...'
          call dumpfilter(laplac)
       end if

    case default
       write(0,*) 'Testmatch'
       call seperr('dimensionality not implemented')
    end select

  end subroutine laplac1_init

	subroutine row_laplac_init (laplac1,laplac2,nsmatch1,nsmatch2,npatch)
    type  (filter)        :: laplac1
    type  (filter)        :: laplac2
    type (nfilter)        :: nsmatch1
    type (nfilter)        :: nsmatch2
    integer, dimension(:) :: npatch

	call laplac_init(laplac1,nsmatch1,npatch)
	call laplac_init(laplac2,nsmatch2,npatch)
	
	end subroutine row_laplac_init

end program Ultimatch_row
